/*==============================================================================
		アーカイブ可能コンポーネントクラス	for Zeta	Ver 2.00
		Copyright (C) 1999-2004 by ＳＨＩＮＴＡ
==============================================================================*/

/*==============================================================================
 Ver. |					主な改良点
--------------------------------------------------------------------------------
 ---- | 2003/11/16 (Sun) 開発着手。
 1.00 | 2003/11/16 (Sun) add 時代のクラスを元に構築。
 2.00 | 2004/10/11 (Mon) BArchivable の派生にした。
==============================================================================*/

/*=== Memo =====================================================================
==============================================================================*/

//------------------------------------------------------------------------------
#include "Archivable.h"
//------------------------------------------------------------------------------
// BeOS
#include <File.h>
// C++
// Add2
#include <add2/FUConstants.h>
//------------------------------------------------------------------------------
const char	CLASS_NAME_T_ARCHIVABLE[] = "TArchivable";
//==============================================================================
TArchivable::TArchivable()
		: SUPER()
{
}
//------------------------------------------------------------------------------
TArchivable::TArchivable(BMessage* oArc)
		: SUPER(oArc)
{
}
//------------------------------------------------------------------------------
TArchivable::~TArchivable()
{
}
//------------------------------------------------------------------------------
status_t	TArchivable::Archive(BMessage* oArc, bool oDeep) const
{
	status_t	aResult = B_OK;

	aResult |= SUPER::Archive(oArc, oDeep);
	aResult |= oArc->AddString(FUC_ARC_NAME_CLASS_NAME, CLASS_NAME_T_ARCHIVABLE);
	return aResult;
}
//------------------------------------------------------------------------------
status_t	TArchivable::FindBool(const BMessage& oArc, const char* oName, bool* oValue) const
{
	return FindBool(oArc, oName, 0, oValue);
}
//------------------------------------------------------------------------------
status_t	TArchivable::FindBool(const BMessage& oArc, const char* oName, int32 oIdx, bool* oValue) const
{
	bool		aTmp;
	status_t	aResult;

	aResult = oArc.FindBool(oName, oIdx, &aTmp);
	if ( aResult == B_OK ) {
		*oValue = aTmp;
	}
	return aResult;
}
//------------------------------------------------------------------------------
status_t	TArchivable::FindData(const BMessage& oArc, const char* oName, type_code oType, const void** oData, ssize_t* oNumBytes) const
{
	return FindData(oArc, oName, oType, 0, oData, oNumBytes);
}
//------------------------------------------------------------------------------
status_t	TArchivable::FindData(const BMessage& oArc, const char* oName, type_code oType, int32 oIdx, const void** oData, ssize_t* oNumBytes) const
{
	const void*	aTmp;
	ssize_t		aNumBytes;
	status_t	aResult;

	aResult = oArc.FindData(oName, oType, oIdx, &aTmp, &aNumBytes);
	if ( aResult == B_OK ) {
		*oData = aTmp;
		*oNumBytes = aNumBytes;
	}
	return aResult;
}
//------------------------------------------------------------------------------
status_t	TArchivable::FindDouble(const BMessage& oArc, const char* oName, double* oValue) const
{
	return FindDouble(oArc, oName, 0, oValue);
}
//------------------------------------------------------------------------------
status_t	TArchivable::FindDouble(const BMessage& oArc, const char* oName, int32 oIdx, double* oValue) const
{
	double		aTmp;
	status_t	aResult;

	aResult = oArc.FindDouble(oName, oIdx, &aTmp);
	if ( aResult == B_OK ) {
		*oValue = aTmp;
	}
	return aResult;
}
//------------------------------------------------------------------------------
status_t	TArchivable::FindFloat(const BMessage& oArc, const char* oName, float* oValue) const
{
	return FindFloat(oArc, oName, 0, oValue);
}
//------------------------------------------------------------------------------
status_t	TArchivable::FindFloat(const BMessage& oArc, const char* oName, int32 oIdx, float* oValue) const
{
	float		aTmp;
	status_t	aResult;

	aResult = oArc.FindFloat(oName, oIdx, &aTmp);
	if ( aResult == B_OK ) {
		*oValue = aTmp;
	}
	return aResult;
}
//------------------------------------------------------------------------------
status_t	TArchivable::FindInt32(const BMessage& oArc, const char* oName, int32* oValue) const
{
	return FindInt32(oArc, oName, 0, oValue);
}
//------------------------------------------------------------------------------
status_t	TArchivable::FindInt32(const BMessage& oArc, const char* oName, int32 oIdx, int32* oValue) const
{
	int32		aTmp;
	status_t	aResult;

	aResult = oArc.FindInt32(oName, oIdx, &aTmp);
	if ( aResult == B_OK ) {
		*oValue = aTmp;
	}
	return aResult;
}
//------------------------------------------------------------------------------
status_t	TArchivable::FindInt64(const BMessage& oArc, const char* oName, int64* oValue) const
{
	return FindInt64(oArc, oName, 0, oValue);
}
//------------------------------------------------------------------------------
status_t	TArchivable::FindInt64(const BMessage& oArc, const char* oName, int32 oIdx, int64* oValue) const
{
	int64		aTmp;
	status_t	aResult;

	aResult = oArc.FindInt64(oName, oIdx, &aTmp);
	if ( aResult == B_OK ) {
		*oValue = aTmp;
	}
	return aResult;
}
//------------------------------------------------------------------------------
status_t	TArchivable::FindMessage(const BMessage& oArc, const char* oName, BMessage* oValue) const
{
	return FindMessage(oArc, oName, 0, oValue);
}
//------------------------------------------------------------------------------
status_t	TArchivable::FindMessage(const BMessage& oArc, const char* oName, int32 oIdx, BMessage* oValue) const
{
	BMessage	aTmp;
	status_t	aResult;

	aResult = oArc.FindMessage(oName, oIdx, &aTmp);
	if ( aResult == B_OK ) {
		*oValue = aTmp;
	}
	return aResult;
}
//------------------------------------------------------------------------------
status_t	TArchivable::FindRect(const BMessage& oArc, const char* oName, BRect* oValue) const
{
	return FindRect(oArc, oName, 0, oValue);
}
//------------------------------------------------------------------------------
status_t	TArchivable::FindRect(const BMessage& oArc, const char* oName, int32 oIdx, BRect* oValue) const
{
	BRect		aTmp;
	status_t	aResult;

	aResult = oArc.FindRect(oName, oIdx, &aTmp);
	if ( aResult == B_OK ) {
		*oValue = aTmp;
	}
	return aResult;
}
//------------------------------------------------------------------------------
status_t	TArchivable::FindRef(const BMessage& oArc, const char* oName, entry_ref* oValue) const
{
	return FindRef(oArc, oName, 0, oValue);
}
//------------------------------------------------------------------------------
status_t	TArchivable::FindRef(const BMessage& oArc, const char* oName, int32 oIdx, entry_ref* oValue) const
{
	entry_ref	aTmp;
	status_t	aResult;

	aResult = oArc.FindRef(oName, oIdx, &aTmp);
	if ( aResult == B_OK ) {
		*oValue = aTmp;
	}
	return aResult;
}
//------------------------------------------------------------------------------
status_t	TArchivable::FindRGBColor(const BMessage& oArc, const char* oName, rgb_color* oValue) const
{
	return FindRGBColor(oArc, oName, 0, oValue);
}
//------------------------------------------------------------------------------
status_t	TArchivable::FindRGBColor(const BMessage& oArc, const char* oName, int32 oIdx, rgb_color* oValue) const
{
	const void*	aData;
	ssize_t		aDataSize;
	status_t	aResult;

	aResult = FindData(oArc, oName, B_RAW_TYPE, &aData, &aDataSize);
	if ( aResult == B_OK ) {
		memcpy(oValue, aData, sizeof(*oValue));
	}
	return aResult;
}
//------------------------------------------------------------------------------
status_t	TArchivable::FindString(const BMessage& oArc, const char* oName, const char** oValue) const
{
	return FindString(oArc, oName, 0, oValue);
}
//------------------------------------------------------------------------------
status_t	TArchivable::FindString(const BMessage& oArc, const char* oName, int32 oIdx, const char** oValue) const
{
	const char*	aTmp;
	status_t	aResult;

	aResult = oArc.FindString(oName, oIdx, &aTmp);
	if ( aResult == B_OK ) {
		*oValue = aTmp;
	}
	return aResult;
}
//------------------------------------------------------------------------------
status_t	TArchivable::FindString(const BMessage& oArc, const char* oName, string* oValue) const
{
	return FindString(oArc, oName, 0, oValue);
}
//------------------------------------------------------------------------------
status_t	TArchivable::FindString(const BMessage& oArc, const char* oName, int32 oIdx, string* oValue) const
{
	const char*	aTmp;
	status_t	aResult;

	aResult = oArc.FindString(oName, oIdx, &aTmp);
	if ( aResult == B_OK ) {
		*oValue = aTmp;
	}
	return aResult;
}
//------------------------------------------------------------------------------
BArchivable*	TArchivable::Instantiate(BMessage* oArc)
{
	if ( !validate_instantiation(oArc, CLASS_NAME_T_ARCHIVABLE) )
		return NULL;
	return new TArchivable(oArc); 
}
//------------------------------------------------------------------------------
status_t	TArchivable::Load(const BEntry& oEntry)
{
	BFile			aRecF;
	BMessage		aArc;

	if ( aRecF.SetTo(&oEntry, B_READ_ONLY) != B_OK )
		return B_ERROR;
	if ( aArc.Unflatten(&aRecF) != B_OK )
		return B_ERROR;
	if ( Unarchive(aArc) != B_OK )
		return B_ERROR;
	return B_OK;
}
//------------------------------------------------------------------------------
status_t	TArchivable::Save(const BEntry& oEntry) const
{
	BFile		aRecF;
	BMessage	aArc;

	if ( aRecF.SetTo(&oEntry, B_WRITE_ONLY|B_CREATE_FILE|B_ERASE_FILE) != B_OK )
		return B_ERROR;
	if ( Archive(&aArc) != B_OK )
		return B_ERROR;
	if ( aArc.Flatten(&aRecF) != B_OK )
		return B_ERROR;
	return B_OK;
}
//------------------------------------------------------------------------------
status_t	TArchivable::Unarchive(const BMessage& oArc)
{
	return B_OK;
}
//------------------------------------------------------------------------------
//==============================================================================
