#ifndef	___BitmapButton_H_
#define	___BitmapButton_H_
//------------------------------------------------------------------------------
// BeOS
#include <PictureButton.h>	// B_ONE_STATE_BUTTON など
// C++
// Add2
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
enum	{ BB_STATE_ENABLED_OFF, BB_STATE_ENABLED_ON, BB_STATE_DISABLED_OFF, BB_STATE_DISABLED_ON,
		BB_STATE_HOT_OFF, BB_STATE_HOT_ON /* 実際には使われない */, BB_STATE_END };
//------------------------------------------------------------------------------
//==============================================================================
class	TBitmapButton : public BControl
{
public:
	// oEnabledOff は NULL 可だが、アタッチされるまでには指定されていなくてはならない
	// oEnabledOff の所有権は TBitmapButton に移る
	// oLabel は NULL 不可（後に落ちる）
	TBitmapButton(BRect oFrame, const char* oName, BBitmap* oEnabledOff, BMessage* oMsg,
			uint32 oBehavior = B_ONE_STATE_BUTTON);
	TBitmapButton(BRect oFrame, const char* oName, BBitmap* oEnabledOff, const char* oLabel, BMessage* oMsg,
			uint32 oBehavior = B_ONE_STATE_BUTTON);
	~TBitmapButton();

	// イメージ
	status_t			SetImage(int32 oWhich, BBitmap* oImg);
	status_t			SetDefaultImages();								// 設定されていないビットマップを作成 | 1 つ以上作成した
	status_t			SetDefaultImages(const rgb_color& oBGColor);	// 設定されていないビットマップを作成 | 1 つ以上作成した
	status_t			ClearImages();									// ビットマップを全てクリア（BB_STATE_ENABLED_OFF は除く）

	// ラベル
	virtual void		SetLabel(const char* oLabel);

	// 配置
	virtual void		SetAlignment(alignment oForImage, alignment oForLabel);	// 未実装
	void				GetAlignment(alignment* oForImage, alignment* oForLabel) const;	// 未実装
	virtual void		SetDivider(float oDivider);				// 画像を設定した時は自動設定
	virtual void		ResizeToPreferred();

	// ONE / TWO STATE
	virtual status_t	SetBehavior(uint32 oBehavior);
	uint32				Behavior() const;

	virtual void		SetValue(int32 oValue);

private:
	typedef	BControl	SUPER;

	void			AdjustDivider();
	virtual void	AttachedToWindow();
	void			CalcDrawPoints();
	void			ConvertFilledCopy(const BBitmap* oSrc, BBitmap** oDest, const rgb_color& oDestColor);		// 色を変換しながらコピー
	void			ConvertTransparentCopy(const BBitmap* oSrc, BBitmap** oDest, const rgb_color& oDestColor);	// 色を変換しながらコピー
	BBitmap*		CreateSlidedBitmap(const BBitmap* oSrc, const rgb_color& oBGColor) const;
	virtual void	Draw(BRect oUpdateRect);
	void			Init(const char* oName, BBitmap* oEnabledOff, uint32 oBehavior);
	float			MinWidth() const;
	virtual void	MouseDown(BPoint oPoint);
	virtual void	MouseMoved(BPoint oPoint, uint32 oTransit, const BMessage* oMsg);
	virtual void	MouseUp(BPoint oPoint);
	virtual void	WindowActivated(bool oActive);

	bool			mChanging;					// OFF → ON or ON → OFF の途中
	bool			mFlat;						// フラットボタン
	bool			mHot;						// ホット
	uint32			mBehavior;					// ONE / TWO STATE
	float			mDivider;
	alignment		mImageAlign;				// 画像の配置
	alignment		mLabelAlign;				// ラベルの配置
	BBitmap*		mImages[BB_STATE_END];		// 表示する画像
	BPoint			mImagePoint;				// 画像を表示する位置
	BPoint			mLabelPoint;				// ラベルを表示する位置
};
//==============================================================================
#endif	// ___BitmapButton_H_
