#ifndef	___ExplorerView_H_
#define	___ExplorerView_H_
//------------------------------------------------------------------------------
// BeOS
#include <OutlineListView.h>
#include <VolumeRoster.h>
// C++
#include <string>
// Add
//------------------------------------------------------------------------------
using namespace	std;
//------------------------------------------------------------------------------
typedef enum	{ EVS_INIT, EVS_OLD, EVS_LATEST } TEVItemStatus;
//------------------------------------------------------------------------------
const char	MSG_NAME_EVITEM_POINTER[] = "EVIPtr";
//==============================================================================
class	TEVItem : public BStringItem
{
public:
	TEVItem(const string& oFolder, uint32 oLevel = 0, bool oExpanded = true);
	~TEVItem();

	string			Folder() const;
	void			SetStatus(TEVItemStatus oState);
	TEVItemStatus	Status() const;

private:
	typedef	BStringItem	SUPER;

	virtual void	DrawItem(BView* oOwner, BRect oItemRect, bool oDrawEverything = false);
	virtual void	Update(BView* oOwner, const BFont* oFont);

	string			mFolder;
	TEVItemStatus	mStatus;
};
//==============================================================================
class	TExplorerView : public BOutlineListView
{
public:
	TExplorerView(BRect oFrame, const char* oName, list_view_type oType = B_SINGLE_SELECTION_LIST,
			uint32 oResizingMode = B_FOLLOW_LEFT|B_FOLLOW_TOP, uint32 oFlags = B_WILL_DRAW|B_FRAME_EVENTS|B_NAVIGABLE);
	~TExplorerView();

	status_t		SetRootFolder(const string& oRootFolder);
	void			Update(const string& oParentFolder);

protected:
	virtual bool	AddItemRequested(const string& oFolder);			// アイテムを追加してもよいかどうか
	virtual void	AddTreeDone(int32 oParentIdx);						// ツリー一枝の追加が完了した
	virtual void	AttachedToWindow();
	virtual void	MessageReceived(BMessage* oMsg);

private:
	typedef	BOutlineListView	SUPER;

	static int		CompareEVItem(const void* oLHS, const void* oRHS);	// 比較関数
	static int		CompareEVItem(const BListItem* oLHS, const BListItem* oRHS);	// 比較関数
	static int		CompareEVItemCore(const TEVItem* oLHS, const TEVItem* oRHS);	// 比較関数

	void			AddRootTree();					// ルートアイテムを追加
	void			AddTree(int32 oParentIdx);		// oParentIdx の子にアイテムを追加
	TEVItem*		FindItem(const string& oFolder);	// ツリーの中を検索
	TEVItem*		FindItem(const BList& oList, const string& oFolder);	// BList の中を検索
	void			Init();
	void			InitEVItemRequested(BMessage* oMsg);
	void			UpdateEVItemRequested(BMessage* oMsg);
	void			UpdateTree(int32 oParentIdx);	// oParentIdx の子アイテムを最新の状態に合わせる

	bool			mShowRootFolder;				// ルートフォルダを表示するかどうか
	string			mDesktopFolder;					// デスクトップのパス
	string			mIgnoreFolders;					// "//FolderName//FolderName" の形で格納（検索しやすいように）
	string			mRootFolder;					// ルートフォルダ
	BVolumeRoster*	mVolumeRoster;					// ボリューム管理
};
//==============================================================================
#endif	// ___ExplorerView_H_
