/*==============================================================================
		基本ファイルクラス	for Zeta	Ver 1.00
		Copyright (C) 2003 by ＳＨＩＮＴＡ
==============================================================================*/

/*==============================================================================
 Ver. |					主な改良点
--------------------------------------------------------------------------------
 ---- | 2003/11/22 (Sat) 開発着手。
 1.00 | 2003/11/22 (Sat) add 時代のクラスを元に構築。
==============================================================================*/

/*=== Memo =====================================================================
==============================================================================*/

//------------------------------------------------------------------------------
#include "FileBase.h"
//------------------------------------------------------------------------------
// BeOS
// C++
// Add2
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//==============================================================================
TBasicFile::TBasicFile()
{
}
//------------------------------------------------------------------------------
TBasicFile::TBasicFile(const entry_ref* oERef, uint32 oOpenMode)
		: SUPER(oERef, oOpenMode)
{
}
//------------------------------------------------------------------------------
TBasicFile::TBasicFile(const BEntry* oEntry, uint32 oOpenMode)
		: SUPER(oEntry, oOpenMode)
{
}
//------------------------------------------------------------------------------
TBasicFile::TBasicFile(const char* oPath, uint32 oOpenMode)
		: SUPER(oPath, oOpenMode)
{
}
//------------------------------------------------------------------------------
TBasicFile::TBasicFile(const BDirectory* oDir, const char* oPath, uint32 oOpenMode)
		: SUPER(oDir, oPath, oOpenMode)
{
}
//------------------------------------------------------------------------------
TBasicFile::TBasicFile(const BFile& oFile)
		: SUPER(oFile)
{
}
//------------------------------------------------------------------------------
TBasicFile::~TBasicFile()
{
}
//------------------------------------------------------------------------------
bool	TBasicFile::Eof() const
{
	off_t	aSize;

	GetSize(&aSize);
	return (Position() >= aSize);
}
//------------------------------------------------------------------------------
ssize_t	TBasicFile::ReadLine(char* oBuf, ssize_t oBufSize)
{
	ssize_t	aCount = 0;

	while ( aCount < oBufSize-1 && !Eof() ) {
		Read(&oBuf[aCount], 1);
		if ( oBuf[aCount] == '\n' )
			break;
		aCount++;
	}
	if ( aCount > 0 && oBuf[aCount-1] == '\r' ) {
		// \r\n の場合
		aCount--;
	}
	oBuf[aCount] = '\0';
	return aCount;
}
//------------------------------------------------------------------------------
ssize_t	TBasicFile::ReadLine(string* oBuf)
{
	char	aTmp;

	*oBuf = "";
	while ( !Eof() ) {
		Read(&aTmp, 1);
		if ( aTmp == '\n' )
			break;
		oBuf->append(1, aTmp);
	}
	if ( oBuf->length() > 0 && (*oBuf)[oBuf->length()-1] == '\r' ) {
		// \r\n の場合
		oBuf->resize(oBuf->length()-1);
	}
	return oBuf->length();
}
//------------------------------------------------------------------------------
ssize_t	TBasicFile::WriteLine(const char* oBuf)
{
	ssize_t	aSize;

	aSize = Write(oBuf, strlen(oBuf));
	aSize += Write("\n", 1);
	return aSize;
}
//------------------------------------------------------------------------------
ssize_t	TBasicFile::WriteLine(const string& oBuf)
{
	ssize_t	aSize;

	aSize = Write(oBuf.c_str(), oBuf.length());
	aSize += Write("\n", 1);
	return aSize;
}
//==============================================================================
