#ifndef	___ScrollTabView_H_
#define	___ScrollTabView_H_
//------------------------------------------------------------------------------
// BeOS
#include <interface/TabView.h>
// Add2
#include "MouseDownManager.h"
#include "ToolBar.h"
//==============================================================================
class	TScrollTabView : public BTabView, public TMouseDownManager, public BInvoker
{
public:
	TScrollTabView(BRect oFrame, const char* oName, button_width oWidth = B_WIDTH_AS_USUAL,
			uint32 oResizingMode = B_FOLLOW_ALL_SIDES, uint32 oFlags = B_FULL_UPDATE_ON_RESIZE|B_WILL_DRAW|B_NAVIGABLE_JUMP|B_FRAME_EVENTS|B_NAVIGABLE);
	virtual	~TScrollTabView();

	virtual void	AddTab(BView* oTgt, BTab* oTab = NULL);
	virtual void	AllAttached();
	void			CheckSelectionChange();
	virtual void	FrameResized(float oWidth, float oHeight);
	virtual void	MessageReceived(BMessage* oMsg);
	virtual void	MouseDown(BPoint oPoint);
	virtual void	MouseDragBeginLeft(BPoint oBeginPoint, BPoint oPoint);		// 左ボタンドラッグ開始
	virtual void	MouseDraggingLeft(BPoint oBeginPoint, BPoint oPoint);		// 左ボタンドラッグ中
	virtual void	MouseMoved(BPoint oPoint, uint32 oTransit, const BMessage* oMsg);
	virtual void	MouseUp(BPoint oPoint);
	virtual BTab*	RemoveTab(int32 oTabIdx);
	virtual BRect	TabFrame(int32 oTabIdx) const;

private:
	typedef	BTabView	SUPER;

	void			InvalidateTabs();
	void			TButtonScrlLeftClicked();
	void			TButtonScrlRightClicked();
	void			UpdateScrollButtons();

	bool			mShowScrlButtons;
	int32			mLastSelection;
	float			mScrlPos;
	float			mScrlPosOnDragBegin;
	TToolButton*	mTButtonLeft;
	TToolButton*	mTButtonRight;
};
//------------------------------------------------------------------------------
//==============================================================================
#endif	// ___ScrollTabView_H_
