#ifndef	___SimpleInput_H_
#define	___SimpleInput_H_
//------------------------------------------------------------------------------
// BeOS
#include <Button.h>
#include <FilePanel.h>
#include <String.h>
#include <TextControl.h>
// Add2
#include <add2/GUIBase.h>
//------------------------------------------------------------------------------
const uint32	SID_SIMPLE_INPUT_TEXT_CHANGED = 'SItc';				// TSimpleInputのテキストが変更された
//------------------------------------------------------------------------------
const char		SID_MSG_NAME_SIMPLE_INPUT_TEXT[] = "SISmplIptTxt";	// TSimpleInputのテキスト
//==============================================================================
class	TSimpleInputView : public TDialogView
{
public:
	TSimpleInputView(BRect oFrame, button_width oWidthStyle);
	~TSimpleInputView();

	void			SelectAll();					// 全テキストを選択

protected:
	virtual void	AttachedToWindow();
	virtual void	ButtonCancelClicked();
	virtual void	ButtonOKClicked();
	virtual void	MessageReceived(BMessage* oMsg);
	virtual void	ShortCutDown(int32 oChar, int32 oFunc);

private:
	friend class	TSimpleInputWindow;
	
	typedef	TDialogView	SUPER;

	void		AdjustButtonArrange();					// ボタンの配置を最適化
	void		AdjustButtonWidth(BButton* oButton);	// ボタンの幅を最適化
	const char*	Text();									// テキスト
	void		SetButtonLabel(file_panel_button oWhichButton, const char* oLabel);	// ボタンラベルの設定
	void		SetLabel(const char* oLabel);			// テキストラベルの設定
	void		SetText(const char* oText);				// テキストの設定

	button_width	mWidthStyle;					// ボタン幅の調節
	BButton*		mButtonOK;						// 右側のボタン
	BButton*		mButtonCancel;					// 左側のボタン
	BString			mPrevText;						// 直前に設定されていたテキスト
	BTextControl*	mTxtCtrlText;					// テキスト入力用
};
//==============================================================================
class	TSimpleInputWindow : public TDialogWindow
{
public:
	TSimpleInputWindow(BRect oFrame, const char* oTitle = "", button_width oWidthStyle = B_WIDTH_AS_USUAL);
	~TSimpleInputWindow();

	virtual void	Appear();							// テキストを選択状態にする
	const char*		Text();								// データ
	virtual bool	QuitRequested();
	void			SetButtonLabel(file_panel_button oWhichButton, const char* oLabel);	// ボタンラベルの設定
	void			SetLabel(const char* oLabel);		// テキストラベルの設定
	void			SetText(const char* oText);			// テキストの設定

protected:
	TSimpleInputView*	mSimpleInputView;

private:
	typedef	TDialogWindow	SUPER;
};
//==============================================================================
#endif	//___SimpleInput_H_
