#ifndef	___StringUtils_H_
#define	___StringUtils_H_
//------------------------------------------------------------------------------
// C++
#include <string>
//==============================================================================
string			add_ext(const string& oOrgFName, const string& oExt);	// 拡張子追加（すでに拡張子がある場合は変更しない） | 変更後のファイル名
		// oExt:ピリオド無し
string			reext(const string& oOrgFName, const string& oExt);	// 拡張子変更（まだ拡張子が無い場合は追加） | 変更後のファイル名
		// oExt:ピリオド無し
string			extract_file_body(const string& oFullPath);			// ファイル名本体（パス・ピリオド・拡張子無し）の抜きだし
string			extract_file_ext(const string& oFullPath);			// 拡張子（ピリオド無し）の抜きだし
string			extract_file_name(const string& oFullPath);			// ファイル名の抜き出し
string			relative_path(const string& oFrom, const string& oTo);	// oFrom から oTo への相対パスを返す
string			trim(const string& oSrc);							// 前後の空白を除去
//==============================================================================
// 内部使用
string	extract_file_folder_path_kernel(const string& oFullPath, int oAddOffset);
//==============================================================================
// インライン
inline string	extract_file_folder(const string& oFullPath)		// ファイルパス（'/'無し）の抜き出し
{
	return extract_file_folder_path_kernel(oFullPath, 0);
}
inline string	extract_file_path(const string& oFullPath)			// ファイルパス（'/'付き）の抜き出し
{
	return extract_file_folder_path_kernel(oFullPath, 1);
}
//==============================================================================
#endif	// ___StringUtils_H_
