#ifndef	___Thread_H_
#define	___Thread_H_
//------------------------------------------------------------------------------
// BeOS
#include <InterfaceDefs.h>
//==============================================================================
/* ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
mTerminated を正しく設定しているかぎり、スレッドが終了しているのにクラスオブジェクトが生き残っていることはあるが、その逆はない
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
class	TThread
{
public:
	TThread(const char* oName = "", int32 oPriority = B_NORMAL_PRIORITY);
	TThread(const TThread& oOrig);
	virtual ~TThread();

	bool				IsSuspended() const;						// 現在サスペンド中かどうか
	bool				IsTerminated() const;						// 既に終了したかどうか
	status_t			Resume() const;								// レジューム
	status_t			SetAutoDelete(bool oAutoDelete);			// スレッドが終了したらクラスインスタンスを自動消滅
	status_t			SetName(const char* oName) const;			// 名前の設定
	status_t			SetPriority(int32 oPriority) const;			// プライオリティーの設定
	status_t			Suspend() const;							// サスペンド（ネストしない）
	virtual status_t	Terminate();								// 終了要求
	thread_id			ThreadID() const;							// スレッド ID
	status_t			Wait(status_t* oExitValue = NULL) const;	// 終了するまで待つ

protected:
	virtual int32	Execute() = 0;		// 仕事実行

	volatile bool	mTerminateRqtd;		// 終了要求があった
	thread_id		mThreadID;			// スレッドＩＤ

private:
	static void		ExitThread(void* oCaller);
	static int32	SpawnThread(void* oCaller);

	void			InitTThread(const char* oName, int32 oPriority);

	volatile bool	mAutoDelete;
	volatile bool	mTerminated;
};
//==============================================================================
#endif	// ___Thread_H_
